﻿module GameState
open System.Drawing

type mouse_state = {
    mouse_x : float32;
    mouse_y : float32;
    mouse_left_down : bool;
    mouse_left_pressed : bool;
    mouse_left_released : bool;
    mouse_right_down : bool;
    mouse_right_pressed : bool;
    mouse_right_released : bool;
}

type game_state = {
    gs_draw : Graphics -> unit
    gs_update : float32 -> mouse_state -> game_state_update_res
}
and game_state_update_res =
    | GSU_Normal
    | GSU_Change of game_state
    | GSU_Quit

let empty_mouse_state =
    { mouse_x = 0.f;
      mouse_y = 0.f;
      mouse_left_down = false;
      mouse_left_pressed = false;
      mouse_left_released = false;
      mouse_right_down = false;
      mouse_right_pressed = false;
      mouse_right_released = false }
