﻿module Storage
open Microsoft.Win32

let get_registry =
    let registry = ref None
    fun () ->
        match !registry with
        | Some reg -> reg
        | None ->
            let reg = Registry.CurrentUser.CreateSubKey("Software\\DareIslands")
            registry := Some reg
            reg

let get_str id def_val =
    let reg = get_registry ()
    reg.GetValue(id, def_val) :?> string

let set_str id (v:string) =
    let reg = get_registry ()
    reg.SetValue(id, v)

let get_int id (def_val:int) =
    try System.Int32.Parse(get_str id (string def_val))
    with _ -> def_val

let set_int id (v:int) =
    set_str id (string v)
